<script>
import Vue from 'vue';

export default Vue.extend({
  name: 'SecurityNoticeForm',
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      submitted: false,
      error: false,
    };
  },
  mounted() {
    if (!this.data.form_id) {
      return;
    }

    window.MktoForms2.setOptions({
      formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
    });

    window.MktoForms2.loadForm(
      '//page.gitlab.com',
      '194-VVC-221',
      this.data.form_id,
      (form) => {
        if (!form) {
          this.error = true;
          return;
        }

        form.onSuccess(() => {
          this.$emit('submit');
          this.submitted = true;
          // eslint-disable-next-line no-undef
          dataLayer.push({
            event: this.data.datalayer,
            mktoFormId: form.getId(),
            eventCallback() {
              form.getFormElem().hide();
            },
            eventTimeout: 3000,
          });
          return false;
        });

        function getgacid() {
          try {
            const tracker = ga.getAll()[0]; // eslint-disable-line no-undef
            return tracker.get('clientId');
          } catch (e) {
            return 'n/a';
          }
        }

        form.vals({
          gacid: getgacid(),
        });
      },
    );
  },
});
</script>

<template>
  <div class="form_column slp-px-md-32">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js" />
    <div v-if="data.form_id" class="form_container">
      <div v-if="error" class="error">
        <SlpTypography tag="p" variant="heading4-bold"
          >Sorry! Something went wrong.</SlpTypography
        >
      </div>
      <div v-else>
        <SlpTypography
          v-if="data.form_header && !submitted"
          tag="h4"
          variant="heading4"
          class="form_header"
        >
          {{ data.form_header }}
        </SlpTypography>
        <br />
        <SlpTypography
          v-if="data.form_paragraph && !submitted"
          tag="p"
          variant="body1"
          class="form_paragraph"
        >
          {{ data.form_paragraph }}
        </SlpTypography>
        <SlpTypography
          v-if="!submitted"
          tag="p"
          variant="body4"
          class="required_label"
          >{{ data.form_required_text || 'All fields required' }}
        </SlpTypography>
        <form
          v-if="!submitted"
          :id="`mktoForm_${data.form_id}`"
          class="mktoForm_container"
        ></form>
        <div v-else class="submitted_message">
          <SlpTypography tag="h3" variant="heading3"
            >Thanks for subscribing!
          </SlpTypography>
          <SlpTypography v-if="!submitted" tag="p" variant="body1"
            ><a href="https://www.twitter.com/gitlab">
              Follow us on twitter for even more updates!</a
            >
          </SlpTypography>
        </div>
      </div>
    </div>
    <iframe
      v-if="data.external_form"
      :src="data.external_form.url"
      :width="data.external_form.width"
      :height="data.external_form.height"
    />
  </div>
</template>

<style lang="scss" scoped>
.form_column {
  grid-area: form;

  @media (max-width: $breakpoint-lg) {
    margin-bottom: 3rem;
  }

  iframe {
    display: block;
    margin-left: auto;
    margin-right: auto;
    max-width: 100%;
    border: 1px solid #f2f2f2;
    border-radius: 4px;

    .sid-ltr {
      background-color: white;
    }
  }

  .form_container {
    position: relative;
    background: #ffffff;
    padding: $spacing-32;
    border: 1px solid rgba(0, 0, 0, 0.08);
    border-radius: 4px;

    @media (min-width: $breakpoint-lg) {
      height: 645px;
    }

    .error {
      padding: $spacing-32;
    }
    .error-buttons {
      margin: $spacing-24 0 0 0;

      .slp-btn {
        &:first-of-type {
          margin-bottom: $spacing-8;
        }
        .slp-icon {
          margin-left: $spacing-8;
        }

        @media (max-width: $breakpoint-md) {
          padding: 11px $spacing-16;
          width: 100%;
          justify-content: center;

          .slp-icon {
            display: none;
          }
        }
      }
    }
  }

  .form {
    text-align: left;
  }
}

.form_header {
  text-align: center;
  margin-top: $spacing-16;

  @media (min-width: $breakpoint-md) {
    margin-top: 0;
  }
}

.required_label {
  margin: 1rem 0;
  font-size: 16px;
  @media (max-width: $breakpoint-lg) {
    padding-left: 10px;
  }
}

.submitted_message {
  text-align: center;
  width: 100%;
  height: 30%;

  @media (max-width: $breakpoint-lg) {
    padding: 10px;
  }
}
</style>

<style lang="scss">
.mktoLabel {
  text-transform: lowercase !important;

  &::first-letter {
    text-transform: uppercase;
  }
}

.mktoForm .mktoRequiredField .mktoAsterix {
  display: none !important;
}

.mktoForm .mktoRequiredField label.mktoLabel {
  text-transform: lowercase !important;

  &::first-letter {
    text-transform: uppercase;
  }
}

div.mktoErrorArrowWrap {
  display: none;
}

.mktoForm.mktoLayoutAbove input.mktoField:focus,
.mktoForm.mktoLayoutAbove select.mktoField:focus {
  box-shadow: none;
}

.mktoForm .mktoError div.mktoErrorMsg {
  background: transparent;
  color: #333;
  border: none;
  box-shadow: none;
  display: inline;
  text-shadow: none;
  font-size: 12px;
  line-height: 20px;

  span.mktoErrorDetail {
    display: inline;
  }
}

.mktoForm .mktoError {
  position: unset !important;
}

.mktoForm_container {
  width: 100% !important;

  .mktoField:not([type='radio']) {
    min-height: 48px;
  }

  .mktoFieldDescriptor .mktoFieldWrap input.mktoInvalid {
    border: 1px solid #f24f63;
  }

  .mktoFormRow {
    width: 100%;

    input:not([type='radio']) {
      width: 100%;
    }
  }

  .mktoHasWidth {
    width: 100% !important;
    margin-bottom: 16px;
  }

  .mktoFieldWrap,
  .mktoFormCol,
  #commentCapture {
    width: 100%;
    margin-bottom: 0;
  }

  .mktoLogicalField.mktoCheckboxList.mktoHasWidth {
    display: flex;

    input[type='checkbox'] {
      width: 30px !important;
    }

    label {
      margin-left: 0.5rem;
      display: flex;
      align-items: center;
    }
  }

  .mktoFieldWrap
    input:not([type='checkbox']):not([type='radio']):not([type='hidden']),
  .mktoFieldWrap select {
    width: 100% !important;
    border: 1px solid #333333;
    border-radius: 4px;
    padding: 12px 16px;
    margin-bottom: 5px;
  }

  .mktoFieldWrap label {
    float: left;
    margin-bottom: 4px;
  }

  .mktoButtonRow {
    width: 100% !important;

    .mktoButtonWrap {
      margin-left: 0 !important;
      width: 100% !important;

      button {
        width: 100% !important;
        background-color: $color-primary-200 !important;
        color: $color-text-50 !important;
        border: 1px solid $color-primary-200 !important;
        background-image: none !important;
        display: inline-block;
        padding: 4px 30px;
        font-size: 16px;
        line-height: 40px;
        min-width: 140px;
        min-height: 52px;
        border-radius: 4px;
        margin-bottom: 20px;
        cursor: pointer;
        transition: all 0.3s ease-in-out;

        &:hover {
          background-color: $color-primary-300 !important;
          color: $color-text-300 !important;
          border: 1px solid $color-primary-200 !important;
        }
      }
    }
  }

  a:not(.btn):not(.slp-btn),
  a:not(.btn):not(.slp-btn):active,
  a:not(.btn):not(.slp-btn):hover,
  a:not(.btn):not(.slp-btn):focus {
    color: #7d2bd9;
  }
}
</style>
